<?
class classSearch
{
    public function getTopResult($q)
    {
        $url = $this->getCache($q);
        if ($url == '')
        {
            $client = new SoapClient( '../lib/GoogleSearch.wsdl', array("trace"=>1,"exceptions"=>0) );
        
            $result = $client->doGoogleSearch(
                    ".....",    // Insert your Google web search API key
                    $q,   // search term
                    0,               // start from result n
                    1,              // number of results - max is 10
                    FALSE,           // filter - remove similar results
                    '',              // restrict by topic
                    false,           // Safesearch - remove adult links
                    '',              // restrict by language
                    '', '');          // last 2 ignored
        
            if ( is_array($result->resultElements) ) {
                foreach($result->resultElements as $hit) {
                    $url = '<a href="' . misc_toAttribute($hit->URL) . '">' . $hit->title  . '</a><br />' .
                            $hit->snippet;
                    $url = str_replace('<b>', '<strong>', $url);
                    $url = str_replace('</b>', '</strong>', $url);
                    break;
                }
            }
    
            if ($url != null && $url != '') {
                $this->setCache($q, $url);
            }
        }

        return $url;
    }

    private function getCache($query)
    {
        $result = '';
        $query = 'SELECT id, result FROM up_searchCache ' .
                'WHERE query = ' . smartQuote($query) . ' AND dateCreated LIKE "' . getIsoMonth() . '-%" ' .
                'LIMIT 1';
        $rows = mysql_query($query) or die( 'Error <!-- getCache ' . mysql_error() . ' -->' );

        while ( $c = mysql_fetch_array($rows) ) {
            $result = $c['result'];
            break;
        }
    
        return $result;
    }

    private function setCache($query, $result)
    {
        $dateCreated = getIsoDate();
        $query = 'INSERT INTO up_searchCache (query, result, dateCreated) ' .
                'VALUES (' . smartQuote($query) . ', ' . smartQuote($result) . ', ' . smartQuote($dateCreated) . ')';
        $rows = mysql_query($query) or die( 'Error <!-- setCache ' . mysql_error() . ' -->' );
    }
}

?>