<?

function smartQuote($v)
{
    if ( get_magic_quotes_gpc() ) {
        $v = stripslashes($v);
    }
    if ( !is_numeric($v) ) {
        $v = "'" . mysql_real_escape_string($v) . "'";
    }

    return $v;
}

function getTextBetween($textPar, $startText, $endText, $offset = 0)
{
    $text = "--" . $textPar . "--";
    $textBetween = "";
    $i = 0;
    $startPosition = 0;

    for ($i = 0; $i <= $offset; $i++)
    {
        $startPosition = strPos($text, $startText, $startPosition);

        if ($startPosition >= 1)
        {
            $startPosition += strLen($startText);
            $textFromHere = subStr($text, $startPosition);
            $endPosition = strPos($textFromHere, $endText);
    
            if ($endPosition >= 1 && $i == $offset)
            {
                $textBetween = subStr($textFromHere, 0, $endPosition);
            }
        }
    }

    return $textBetween;
}


function getFileText($filePath)
{
    $filetext = '';

    if ( strpos($filePath, '://') >= 1 ) {
        $filetext = getFileText_external($filePath);
    }
    else {
        $filetext = getFileText_local($filePath);
    }

    return $filetext;
}

function getFileText_external($filePath)
{
    $filetext = '';

    if ( strpos($filePath, '://') >= 1 )
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $filePath);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $filetext = curl_exec($ch);
        curl_close($ch);
    }

    return $filetext;
}

function getFileText_local($filePath)
{
    // local, or PHP4
    $fileText = "";

    $fileArray = file($filePath);
    $countFile = count($fileArray);
    for ($i = 0; $i < $countFile; $i++) {
        $fileText .= $fileArray[$i];
    }

    return $fileText;
}

function setFileText($filePath, $fileText)
{
    $writingOnly = "w";
    $fileHandle = fOpen($filePath, $writingOnly);
    fWrite($fileHandle, $fileText);
    fClose($fileHandle);
}

function getIsoDate()
{
    $today = getdate();
    $year = $today['year'];
    $mon = pad($today['mon']);
    $mday = pad($today['mday']);
    $hours = pad($today['hours']);
    $minutes = pad($today['minutes']);
    $seconds = pad($today['seconds']);
    return "$year-$mon-$mday $hours:$minutes:$seconds";
}

function pad($thisValue)
{
    $newValue = $thisValue;
    if ( strlen($thisValue) == 1 )
    {
        $newValue = "0" . $newValue;
    }
    return $newValue;
}

function misc_toXml($s)
{
    $s = str_replace('&', '&amp;', $s);
    $s = str_replace('<', '&lt;', $s);
    $s = str_replace('>', '&gt;', $s);

    return $s;
}

function misc_toAttribute($s)
{
    $s = misc_toXml($s);
    $s = str_replace('"', '&quot;', $s);

    return $s;
}

function misc_toName($s)
{
    $s = strtolower($s);
    $abc = 'abcdefghijklmnopqrstuvwxyz';
    $sNew = '';

    for ($i = 0; $i < strlen($s); $i++)
    {
        $letter = substr($s, $i, 1);
        if ( strpos($abc, $letter) === false )
        {
            $letter = '';
        }

        $sNew .= $letter;
    }

    return $sNew;
}

?>