<?
class classRss
{
    public function update()
    {
        $relPath = ( file_exists('rss/rss.template') ) ? '' : '../';
        $template = getFileText($relPath . 'rss/rss.template');
        $rss = $this->getContent($template);
        setFileText($relPath . 'rss/latest.xml', $rss);
    }
    
    private function getContent($s)
    {
        $query = 'SELECT id, title, userName, url, dateCreated FROM up_item ' .
                'ORDER BY dateCreated DESC LIMIT 20';
        $rows = mysql_query($query) or die('Error');
        $latestDate = '';
        $sItems = '';
        while ( $c = mysql_fetch_array($rows) ) {
            $thisDate = $this->getDate($c['dateCreated']);
            if ($latestDate == '') { $latestDate = $thisDate; }
            $sItems .= $this->getItem($c['id'], $c['title'], $c['userName'], $c['url'], $thisDate);
        }
    
        $s = str_replace('<!-- title -->', 'Upwarded - Latest Links', $s);
        $s = str_replace('<!-- latest date -->', $latestDate, $s);
        $s = str_replace('<!-- items -->', $sItems, $s);
    
        return $s;
    }
    
    private function getItem($id, $title, $userName, $url, $thisDate)
    {
        $s = '';
        $permalink = 'http://www.upwarded.com/item/' . urlencode($id);

        $s .= '<item>' . "\r";
        $s .= '<title>' . toXml($title) . '</title>' . "\r";
        $s .= '<link>' . $permalink . '</link>' . "\r";
        $s .= '<guid>' . $permalink . '</guid>' . "\r";
        $s .= '<pubDate>' . $thisDate . '</pubDate>' . "\r";
        $s .= '<description>' . toXml($title) . '</description>' . "\r";
        $s .= '<content:encoded><![CDATA[<a href="' . toAttribute($url) . '">' . toXml($title) . '</a> ' .
                'by ' . toXml($userName) . ' ' .
                '(<a href="' . $permalink . '">View thread...</a>)]]></content:encoded>' . "\r";
        $s .= "\r";
        $s .= '</item>' . "\r"; $s .= "\r";

        return $s;
    }
    
    private function getDate($isodatetime)
    {
        list($isodate, $isotime) = explode(' ', $isodatetime);
        list($sHour, $sMinute, $sSecond) = explode(':', $isotime);
        list($sYear, $sMonth, $sDay) = explode('-', $isodate);
        $timestamp = mktime($sHour, $sMinute, $sSecond, $sMonth, $sDay, $sYear);
        $sDate = date('D, j M Y ' . $isotime . ' +0100', $timestamp);
        return $sDate;
    }
}

?>